//
// kiru.c
// Q[{
//
// Copyright (c) 2021 ڂ(@voich2014 in Twitter)
//
// Released under the MIT license.
// see https://opensource.org/licenses/MIT
// Where a citation is listed, please also check the license of the citing source.
//

#include "cmnlib.h"

//---------------------------------------------------------------------------
// 萔` 
//---------------------------------------------------------------------------
#define PLAYER_RUN_PT	(0x10)			//vC[p^[̊Jn^CCfbNX
#define PLAYER_KIRU_PT	(0x18)			//vC[ap^[̊Jn^CCfbNX
#define PLAYER_BUKI_PT	(0x1C)			//vC[̓p^[̊Jn^CCfbNX
#define PLAYER_DEAD_PT	(0x1E)			//vC[̓|p^[̊Jn^CCfbNX
#define ENEMY_RUN_PT	(0x20)			//Gp^[̊Jn^CCfbNX
#define ENEMY_KIRU_PT	(0x28)			//Gap^[̊Jn^CCfbNX
#define ENEMY_BUKI_PT	(0x2C)			//G̓p^[̊Jn^CCfbNX
#define ENEMY_DEAD_PT	(0x2E)			//G̓|p^[̊Jn^CCfbNX
#define COVER_PT		(0x30)			//Jo[XvCgp^[̃^CCfbNX
#define CLOUD_PT		(0x32)			//_XvCgp^[̊Jn^CCfbNX
#define STR_P_PT		(0x01)			//XvCgp^[P̃^CCfbNX
#define STR_U_PT		(0x02)			//XvCgp^[Ũ^CCfbNX
#define STR_S_PT		(0x03)			//XvCgp^[S̃^CCfbNX
#define STR_H_PT		(0x04)			//XvCgp^[H̃^CCfbNX
#define STR_A_PT		(0x05)			//XvCgp^[Ã^CCfbNX
#define STR_B_PT		(0x06)			//XvCgp^[B̃^CCfbNX
#define STR_T_PT		(0x07)			//XvCgp^[T̃^CCfbNX
#define STR_O_PT		(0x08)			//XvCgp^[Õ^CCfbNX
#define STR_N_PT		(0x09)			//XvCgp^[Ñ^CCfbNX

#define PLAYER_SP		(5)				//vC[XvCg̊JnCfbNX
#define PLAYER_BUKI_SP	(9)				//vC[̓XvCg̊JnCfbNX
#define ENEMY_SP		(11)			//GXvCg̊JnCfbNX
#define ENEMY_BUKI_SP	(15)			//G̓XvCg̊JnCfbNX
#define COVER_SP		(1)				//Jo[XvCg̊JnCfbNX
#define STR_SP			(17)			//XvCg̊JnCfbNX
#define CLOUD_SP		(28)			//_XvCg̊JnCfbNX
#define GROUND_Y		(135)			//nʂɗYW
#define PLAYER_X		(100)			//vC[XW
#define ENEMY_X			(200)			//GXWʒu
#define ENEMY_KIRU_X	(84)			//GXWaʒu
#define TITLE_BG_X		(14)			//^CgBGXʒu
#define TITLE_BG_Y		(11)			//^CgBGYʒu
#define KILLED_BG_X		(9)				//alBGXʒu
#define KILLED_BG_Y		(9)				//alBGYʒu
#define WAITSTR_SP_X	(108)			//҂XvCg̍[XW
#define WAITSTR_SP_Y	(102)			//҂XvCgYW
#define CLOUD_X			(174)			//_XvCg̊XW
#define CLOUD_Y			(83)			//_XvCgYW
#define STAGE_LEFT		(56)			//Xe[W̍[
#define STAGE_RIGHT		(192)			//Xe[W̉E[
#define PLAYER_SPEED	(1)				//vC[̈ړx(ꂽG̈ړxj
#define ENEMY_SPEED		(1)				//G̊x
#define KIRU_WAIT		(30)			//vC[a̍d
#define KIRU_TIME		(15)			//vC[a̔L
#define DEAD_WAIT		(60)			//҂
#define CLOUD_ANI_THRE	(120)			//_Phbgړt[JE^臒l
#define CLOUD_MV_WIDTH	(16)			//_̈ړ

#define SCENE_TITLE		(0)				//^CgA{^҂V[
#define SCENE_PLAY		(1)				//Q[V[
#define SCENE_OVER		(2)				//Q[I[o[̃{^҂V[
#define SCENE_ERASE		(3)				//^Cg񕔕V[

//XW𓮂Ȃ̂ŁAXvCg[N̉_̈ʒuAhXvZĂ
#define CLOUD_X1_SPW 	(*(char*)(SPWADDR+4*(CLOUD_SP+0)+3))
#define CLOUD_X2_SPW 	(*(char*)(SPWADDR+4*(CLOUD_SP+1)+3))

//---------------------------------------------------------------------------
// O[oϐ 
//---------------------------------------------------------------------------
unsigned char g_scene     = 0;			//V[ԊǗp
unsigned char g_killed    = 0;			//alǗp
unsigned char g_push_a    = 0;			//A{^gKp
unsigned char g_k_100     = 0; 			//al100̌
unsigned char g_k_10      = 0;			//al10̌
unsigned char g_k_1       = 0;			//al1̌
unsigned char g_pl_action = 0;			//vC[ANVǗp
unsigned char g_fcnt      = 0;			//t[JE^Ǘp(0`239)
unsigned char g_gnd_anime = 0;			//nʂ̃pbgAjJE^Ǘp(0`1)
unsigned char g_cld_dir   = 0;			//_̈ړ
unsigned char g_cld_cnt   = 0;			//_̈ړJEg

//---------------------------------------------------------------------------
//  
//---------------------------------------------------------------------------
void setup_sound(void)
{
		
	//TEh̏
	unsigned char duty,enable_decayloop,enable_decay,decay;
	unsigned char enable_sweep,period,freqdir,freqshift;
	unsigned char rnd_type,noisefreq;
	unsigned char enable_dpcm,enable_noise,enable_triangle,enable_pulse2,enable_pulse1;
	
	//ʉ1(`gCH1)̏
	duty             = 0;	//f[eB 00: 2/14(12.5%) 01: 4/12(25.0%)
							//             10: 8/ 8(50.0%) 11:12/ 4(75.0%)
	enable_decayloop = 1;	//Gx[v[vL(0:OFF 1:ON)
	enable_decay     = 1;	//Gx[vL(0:OFF 1:ON)
	decay            = 10;	//Decay()x 0 ` 15
							//(decay+1)/240bŃ{[P
	enable_sweep     = 1;	//gωL(0:OFF 1:ON)
	period           = 1;	//gω(0 ` 7)
	freqdir          = 1;	//gω(0:ႭȂ 1:Ȃ)
	freqshift        = 2;	//gω(0 ` 7)
	
	PULSE1CTR1 = (duty<<6)+(enable_decayloop<<5)+(enable_decay<<4)+decay;
	PULSE1CTR2 = (enable_sweep<<7)+(period<<4)+(freqdir<<3)+freqshift;
	
	//ʉ2(`gCH2)̏
	duty             = 1;	//f[eB 00: 2/14(12.5%) 01: 4/12(25.0%)
							//             10: 8/ 8(50.0%) 11:12/ 4(75.0%)
	enable_decayloop = 1;	//Gx[v[vL(0:OFF 1:ON)
	enable_decay     = 1;	//Gx[vL(0:OFF 1:ON)
	decay            = 15;	//Decay()x 0 ` 15
							//(decay+1)/240bŃ{[P
	enable_sweep     = 1;	//gωL(0:OFF 1:ON)
	period           = 1;	//gω(0 ` 7)
	freqdir          = 0;	//gω(0:ႭȂ 1:Ȃ)
	freqshift        = 2;	//gω(0 ` 7)
	
	PULSE2CTR1 = (duty<<6)+(enable_decayloop<<5)+(enable_decay<<4)+decay;
	PULSE2CTR2 = (enable_sweep<<7)+(period<<4)+(freqdir<<3)+freqshift;
	
	//gݒNA
	PULSE1FREQ1 = 0;
	PULSE1FREQ2 = 0;
	PULSE2FREQ1 = 0;
	PULSE2FREQ2 = 0;
	
	//ʉ3(mCY)̏
	enable_decayloop = 0;	//Gx[v[vL(0:OFF 1:ON)
	enable_decay     = 0;	//Gx[vL(0:OFF 1:ON)
	decay            = 1;	//Decay()x 0 ` 15
							//(decay+1)/240bŃ{[P
	rnd_type         = 0;	//^Cv(0:32kbit[h 1:93bit[h)
	noisefreq        = 5;	//mCYg(0 ` 15)
	
	NOISECTRL = (enable_decayloop<<5)+(enable_decay<<4)+decay;
	NOISERND  = (rnd_type<<7)+noisefreq;
	
	//ĐԃNA
	NOISETIME = 0;
	
	
	//p`lw
	enable_dpcm     = 0;	//DPCML     (0:OFF 1:ON)
	enable_noise    = 1;	//mCYL   (0:OFF 1:ON)
	enable_triangle = 0;	//OpgchL (0:OFF 1:ON)
	enable_pulse2   = 1;	//`gch2L(0:OFF 1:ON)
	enable_pulse1   = 1;	//`gch1L(0:OFF 1:ON)
	
	SNDCHANNEL = (enable_dpcm<<4)+(enable_noise<<3)+(enable_triangle<<2)+
				 (enable_pulse2<<1)+enable_pulse1;
	
}
//---------------------------------------------------------------------------
void play_se1(void)
{

	//ʉ1炷
	const unsigned short freq = (unsigned short)PULSE_HZ(800);
	
	PULSE1FREQ1 = freq & 0xFF;
	PULSE1FREQ2 = freq >> 8;
	
}
//---------------------------------------------------------------------------
void play_se2(void)
{
	
	//ʉ2炷
	const unsigned short freq = (unsigned short)PULSE_HZ(700);
	
	PULSE2FREQ1 = freq & 0xFF;
	PULSE2FREQ2 = freq >> 8;

}
//---------------------------------------------------------------------------
void play_se3(void)
{
	
	//ʉ3炷
	const unsigned char noisetime = 1;	//mCYĐ(0 ` 31)
	
	NOISETIME = (noisetime<<3);

}
//---------------------------------------------------------------------------
void setup_palette(void)
{
	
	//pbg̏
	//
	// BG̃pbgPPUAhX́A$3F00-$3F0FB
	// XvCg̃pbgPPUAhX́A$3F10-$3F1FB
	//
	// pbg1F1oCg̐FCfbNX(0x00`0x3F)w肵܂B
	// pbg̏ڍׂ͉Ly[WQ
	// https://wiki.nesdev.com/w/index.php/PPU_palettes
	// 
	
	//BGp̃pbgp
	const unsigned char bg_palettes[] =
	{
		0x00, 0x0F, 0x00, 0x20,	//pbg1: wiF,,ZD,
		0x00, 0x11, 0x31, 0x38,	//pbg2: wiF,Â,,F
		0x00, 0x07, 0x17, 0x07,	//pbg3: wiF,ZF,F,ZF
		0x00, 0x11, 0x21, 0x25	//pbg4: wiF,Â,,F
	};
	
	//XvCgp̃pbgp
	//
	// XvCg̃pbg100Ԃ̐FŜ̔wiFɂȂ܂
	//
	const unsigned char sp_palettes[] =
	{
		0x11, 0x0F, 0x2C, 0x36,	//pbg1: Â,,F,F
		0x00, 0x0F, 0x10, 0x36,	//pbg2: ,,DF,F
		0x00, 0x01, 0x10, 0x30,	//pbg3: ,Â,DF,
		0x00, 0x0F, 0x00, 0x38,	//pbg4: ,,ZD,F
	};
	
	//pbgݒ
	set_palette(PAL_KIND_BG,0,&bg_palettes[0   ]);
	set_palette(PAL_KIND_BG,1,&bg_palettes[1<<2]);
	set_palette(PAL_KIND_BG,2,&bg_palettes[2<<2]);
	set_palette(PAL_KIND_BG,3,&bg_palettes[3<<2]);
	
	set_palette(PAL_KIND_SP,0,&sp_palettes[0   ]);
	set_palette(PAL_KIND_SP,1,&sp_palettes[1<<2]);
	set_palette(PAL_KIND_SP,2,&sp_palettes[2<<2]);
	set_palette(PAL_KIND_SP,3,&sp_palettes[3<<2]);

}
//---------------------------------------------------------------------------
void setup_sprite(void)
{
	
	//XvCg̏
	
	//p^[Œ̃XvCgɃZbgĂ
	
	//Jo[XvCg
	set_sp_pettern(COVER_SP  ,COVER_PT);
	set_sp_pettern(COVER_SP+1,COVER_PT);
	set_sp_pettern(COVER_SP+2,COVER_PT);
	set_sp_pettern(COVER_SP+3,COVER_PT);
	
	//vC[̓
	set_sp_pettern(PLAYER_BUKI_SP  ,PLAYER_BUKI_PT  );
	set_sp_pettern(PLAYER_BUKI_SP+1,PLAYER_BUKI_PT+1);
	
	//G̓
	set_sp_pettern(ENEMY_BUKI_SP  ,ENEMY_BUKI_PT  );
	set_sp_pettern(ENEMY_BUKI_SP+1,ENEMY_BUKI_PT+1);
	
	//_
	set_sp_pettern(CLOUD_SP   ,CLOUD_PT  );
	set_sp_pettern(CLOUD_SP+1 ,CLOUD_PT+1);
	
	//{^҂
	set_sp_pettern(STR_SP   ,STR_P_PT);	//P
	set_sp_pettern(STR_SP+1 ,STR_U_PT);	//U
	set_sp_pettern(STR_SP+2 ,STR_S_PT);	//S
	set_sp_pettern(STR_SP+3 ,STR_H_PT);	//H
	set_sp_pettern(STR_SP+4 ,STR_A_PT);	//A
	set_sp_pettern(STR_SP+5 ,STR_B_PT);	//B
	set_sp_pettern(STR_SP+6 ,STR_U_PT);	//U
	set_sp_pettern(STR_SP+7 ,STR_T_PT);	//T
	set_sp_pettern(STR_SP+8 ,STR_T_PT);	//T
	set_sp_pettern(STR_SP+9 ,STR_O_PT);	//O
	set_sp_pettern(STR_SP+10,STR_N_PT);	//N
	
		
	//eXvCg̃pbgݒ
	set_sp_palette(PLAYER_SP       ,0);
	set_sp_palette(PLAYER_SP+1     ,0);
	set_sp_palette(PLAYER_SP+2     ,0);
	set_sp_palette(PLAYER_SP+3     ,0);
	set_sp_palette(PLAYER_BUKI_SP  ,2);
	set_sp_palette(PLAYER_BUKI_SP+1,2);
	set_sp_palette(ENEMY_SP        ,1);
	set_sp_palette(ENEMY_SP+1      ,1);
	set_sp_palette(ENEMY_SP+2      ,1);
	set_sp_palette(ENEMY_SP+3      ,1);
	set_sp_palette(ENEMY_BUKI_SP   ,2);
	set_sp_palette(ENEMY_BUKI_SP+1 ,2);
	set_sp_palette(CLOUD_SP        ,2);
	set_sp_palette(CLOUD_SP+1      ,2);
	set_sp_palette(STR_SP          ,3);	//P
	set_sp_palette(STR_SP+1        ,3);	//U
	set_sp_palette(STR_SP+2        ,3);	//S
	set_sp_palette(STR_SP+3        ,3);	//H
	set_sp_palette(STR_SP+4        ,3);	//A
	set_sp_palette(STR_SP+5        ,3);	//B
	set_sp_palette(STR_SP+6        ,3);	//U
	set_sp_palette(STR_SP+7        ,3);	//T
	set_sp_palette(STR_SP+8        ,3);	//T
	set_sp_palette(STR_SP+9        ,3);	//O
	set_sp_palette(STR_SP+10       ,3);	//N
	
}
//---------------------------------------------------------------------------
void setup_stage(void)
{
	
	//Xe[W̏
	
	//
	// 1ʑŜ256x240hbgB
	// 8x8BG32x30LɂȂ܂B
	// 
	// 1PPUAhX
	// l[e[uF$2000-$23BF
	// e[u@F$23C0-$23FF
	//
	// 2PPUAhX
	// l[e[uF$2400-$27BF
	// e[u@F$27C0-$27FF
	//
	// l[e[u1oCg1L̃^CCfbNX
	// e[úA2x2L1O[vƂāAeO[v
	// Ƃ̃pbgCfbNX2bitŁA1oCg
	// 4O[ṽpbgݒ
	// 
	// BG̃pbg4pbgpł̂ŁA00,01,10,11
	// 4ނZbgł܂B
	//
	// ł́Aʒ16x16̗݂̈āAȊO͍BGɂ܂B
	// 
	// pbg2x2̒PʂłwłȂ̂ŁABG̉2x2ōlȂ
	// ȂłB
	//
	// 
	unsigned short x,y,pos;
	
	//Xe[WBGp^[(16x14)
	const unsigned char stage_bg[] =
	{
	  //0 1 2 3 4 5 6 7 8 9 A B C D E F
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, // 0 
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, // 1
		0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0, // 2
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, // 3
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, // 4
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, // 5
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, // 6
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, // 7
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, // 8
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, // 9
		1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, // A
		1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, // B
		1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, // C
		1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1  // D
	};

	//Xe[W̑e[uf[^
	const unsigned char stage_attr[] =
	{
		0x55,0x55,0x55,0x55,
		0x55,0x55,0x55,0x55,
		0xA5,0xA5,0xA5,0xA5,
		0x0A,0x0A,0x0A,0x0A
	};
	
	const unsigned short STAGE_X      =  8;
	const unsigned short STAGE_Y      =  8;
	const unsigned short STAGE_WIDTH  = 16;
	const unsigned short STAGE_HEIGHT = 14;
	
	//܂͉ʑŜBGŖ߂
	for(y = 0;y < BG_HEIGHT;++y)
	{
		for(x = 0;x < BG_WIDTH;++x)
		{
			set_bg_pattern(x,y,0);
			set_bg_pattern(x,y,0);
		}
	}
	
	//Xe[W̃p^[(l[e[u)Zbg
	pos = 0;
	for(y = 0;y < STAGE_HEIGHT;++y)
	{
		for(x = 0;x < STAGE_WIDTH;++x)
		{
			set_bg_pattern(STAGE_X + x,STAGE_Y + y,
						   stage_bg[pos++]);
		}
	}
	
	//u0lv`Ă
	set_bg_pattern(KILLED_BG_X+2,KILLED_BG_Y,'0');
	set_bg_pattern(KILLED_BG_X+3,KILLED_BG_Y,0xBA);
	
	//Xe[WBGpbg(e[u)Zbg
	pos = 0;
	for(y = 0;y < STAGE_HEIGHT;y += 4)
	{
		for(x = 0;x < STAGE_WIDTH;x += 4)
		{
			set_bg_palette(STAGE_X + x,STAGE_Y + y,
						   stage_attr[pos++]);
		}
	}
	
	//_XvCgzuĂ
	set_sp_pos(CLOUD_SP  ,CLOUD_X  ,CLOUD_Y);
	set_sp_pos(CLOUD_SP+1,CLOUD_X+8,CLOUD_Y);

}
//---------------------------------------------------------------------------
void set_player_sprite(unsigned char x,unsigned char y,
					   unsigned char button)
{
	
	//w̍WɃvC[XvCg\
	//
	// XvCg4g16x16ŕ\܂
	// XvCgԍ͌Œł
	//
	unsigned char anime = ((g_fcnt % 20) >= 10) ? 1 : 0;
	unsigned char kiru  = 0;
	
	//A{^P񉟂痣܂ł͎̍UłȂA
	//1񉟂炵΂炭a|[Yōd悤ɂ܂
	if(((g_pl_action == 0) && (button & BUTTON_A)) || (g_pl_action > 0))
	{	
		//aJn
		if(g_pl_action < KIRU_WAIT)
		{
			if(g_pl_action == 0)
			{	
				//a鉹炷
				play_se1();
			}
			
			kiru = 1;
			g_pl_action++;
		}
		else if((button & BUTTON_A) == 0)
		{
			//dA{^𗣂Ă
			//̎a邪ł悤ɂȂ
			g_pl_action = 0;
		}
	}
	
	if(kiru)
	{
		//aI
		unsigned char idx = PLAYER_KIRU_PT;
		
		set_sp_pettern(PLAYER_SP  ,idx  );
		set_sp_pettern(PLAYER_SP+1,idx+1);
		set_sp_pettern(PLAYER_SP+2,idx+2);
		set_sp_pettern(PLAYER_SP+3,idx+3);
		
		set_sp_pos(PLAYER_SP  ,x - 8,y - 8);
		set_sp_pos(PLAYER_SP+1,x    ,y - 8);
		set_sp_pos(PLAYER_SP+2,x - 8,y    );
		set_sp_pos(PLAYER_SP+3,x    ,y    );
		
		set_sp_pos(PLAYER_BUKI_SP  ,x + 8,y    );
		set_sp_pos(PLAYER_BUKI_SP+1,x +16,y    );
	}
	else
	{
		//܂
		unsigned char idx = PLAYER_RUN_PT + (anime << 2);
		
		set_sp_pettern(PLAYER_SP  ,idx  );
		set_sp_pettern(PLAYER_SP+1,idx+1);
		set_sp_pettern(PLAYER_SP+2,idx+2);
		set_sp_pettern(PLAYER_SP+3,idx+3);
		
		set_sp_pos(PLAYER_SP  ,x - 8,y - 8);
		set_sp_pos(PLAYER_SP+1,x    ,y - 8);
		set_sp_pos(PLAYER_SP+2,x - 8,y    );
		set_sp_pos(PLAYER_SP+3,x    ,y    );
			
		set_sp_pos(PLAYER_BUKI_SP  ,0,OUTSIDE);
		set_sp_pos(PLAYER_BUKI_SP+1,0,OUTSIDE);
	}
	
}
//---------------------------------------------------------------------------
void set_enemy_sprite(unsigned char x,unsigned char y,
					  unsigned char dead_flag)
{

	//w̍WɓG̃XvCg\
	//
	// XvCg4g16x16ŕ\܂
	// XvCgԍ͌Œł
	//
	unsigned char anime  = ((g_fcnt % 20) >= 10) ? 1 : 0;
	
	if(dead_flag)
	{
		//|܂
		set_sp_pettern(ENEMY_SP  ,ENEMY_DEAD_PT  );
		set_sp_pettern(ENEMY_SP+1,ENEMY_DEAD_PT+1);
		
		set_sp_pos(ENEMY_SP  ,x - 8,y);
		set_sp_pos(ENEMY_SP+1,x    ,y);

		set_sp_pos(ENEMY_SP+2     ,0,OUTSIDE);
		set_sp_pos(ENEMY_SP+3     ,0,OUTSIDE);
		set_sp_pos(ENEMY_BUKI_SP  ,0,OUTSIDE);
		set_sp_pos(ENEMY_BUKI_SP+1,0,OUTSIDE);
	}
	else
	{
		//܂
		unsigned char idx = ENEMY_RUN_PT + (anime << 2);
		
		set_sp_pettern(ENEMY_SP  ,idx  );
		set_sp_pettern(ENEMY_SP+1,idx+1);
		set_sp_pettern(ENEMY_SP+2,idx+2);
		set_sp_pettern(ENEMY_SP+3,idx+3);
		
		set_sp_pos(ENEMY_SP  ,x - 8,y - 8);
		set_sp_pos(ENEMY_SP+1,x    ,y - 8);
		set_sp_pos(ENEMY_SP+2,x - 8,y    );
		set_sp_pos(ENEMY_SP+3,x    ,y    );

		set_sp_pos(ENEMY_BUKI_SP  ,0,OUTSIDE);
		set_sp_pos(ENEMY_BUKI_SP+1,0,OUTSIDE);
	}
	
	//Gʒ[ɂ鎞́AXe[W[ŉB߂̃XvCgzu
	if(x <= (STAGE_LEFT+16))
	{
		//Xe[W[B
		set_sp_pos(COVER_SP  ,STAGE_LEFT    ,y - 8);
		set_sp_pos(COVER_SP+1,STAGE_LEFT - 8,y - 8);
		set_sp_pos(COVER_SP+2,STAGE_LEFT    ,y    );
		set_sp_pos(COVER_SP+3,STAGE_LEFT - 8,y    );
	}
	else if(x >= (STAGE_RIGHT-8))
	{
		//Xe[WE[B
		set_sp_pos(COVER_SP  ,STAGE_RIGHT    ,y - 8);
		set_sp_pos(COVER_SP+1,STAGE_RIGHT + 8,y - 8);
		set_sp_pos(COVER_SP+2,STAGE_RIGHT    ,y    );
		set_sp_pos(COVER_SP+3,STAGE_RIGHT + 8,y    );
	}
	else
	{
		//Ȃ悤ɃJo[XvCg͉ʊO֔zu
		set_sp_pos(COVER_SP  ,0,OUTSIDE);
		set_sp_pos(COVER_SP+1,0,OUTSIDE);
		set_sp_pos(COVER_SP+2,0,OUTSIDE);
		set_sp_pos(COVER_SP+3,0,OUTSIDE);
	}

}
//---------------------------------------------------------------------------
unsigned char calc_enemy_x(unsigned char x,unsigned char level,unsigned char dead_flag)
{
	
	//GXWvZ
	unsigned char new_x = x;
	
	if((x < PLAYER_X) || dead_flag)
	{
		//Ă̂ň葬xňړ
		new_x -= PLAYER_SPEED;
	}
	else
	{
		//xɉxňړ
		new_x -= (ENEMY_SPEED * level);
	}

	//Xe[Wɏ܂E[
	if(new_x <= STAGE_LEFT)
	{
		new_x = STAGE_RIGHT + 8;
	}
	
	return new_x;
	
}
//---------------------------------------------------------------------------
void set_string_sprite(void)
{

	//{^҂XvCg\
	
	const char offset[] = { 0,1,1,2,2,2,2,2,1,1,0,-1,-1,-2,-2,-2,-2,-2,-1,-1 };
	unsigned char sp_x = WAITSTR_SP_X;
	unsigned char sp_y = WAITSTR_SP_Y + offset[(g_fcnt % 60) / 3];
	
	set_sp_pos(STR_SP   ,sp_x   ,sp_y   );	//P
	set_sp_pos(STR_SP+1 ,sp_x+ 8,sp_y   );	//U
	set_sp_pos(STR_SP+2 ,sp_x+16,sp_y   );	//S
	set_sp_pos(STR_SP+3 ,sp_x+24,sp_y   );	//H
	set_sp_pos(STR_SP+4 ,sp_x+40,sp_y   );	//A
	set_sp_pos(STR_SP+5 ,sp_x   ,sp_y+10);	//B
	set_sp_pos(STR_SP+6 ,sp_x+ 8,sp_y+10);	//U
	set_sp_pos(STR_SP+7 ,sp_x+16,sp_y+10);	//T
	set_sp_pos(STR_SP+8 ,sp_x+24,sp_y+10);	//T
	set_sp_pos(STR_SP+9 ,sp_x+32,sp_y+10);	//O
	set_sp_pos(STR_SP+10,sp_x+40,sp_y+10);	//N

}
//---------------------------------------------------------------------------
void clear_string_sprite(void)
{
	
	//{^҂XvCg̏
	
	set_sp_pos(STR_SP   ,0,OUTSIDE);	//P
	set_sp_pos(STR_SP+1 ,0,OUTSIDE);	//U
	set_sp_pos(STR_SP+2 ,0,OUTSIDE);	//S
	set_sp_pos(STR_SP+3 ,0,OUTSIDE);	//H
	set_sp_pos(STR_SP+4 ,0,OUTSIDE);	//A
	set_sp_pos(STR_SP+5 ,0,OUTSIDE);	//B
	set_sp_pos(STR_SP+6 ,0,OUTSIDE);	//U
	set_sp_pos(STR_SP+7 ,0,OUTSIDE);	//T
	set_sp_pos(STR_SP+8 ,0,OUTSIDE);	//T
	set_sp_pos(STR_SP+9 ,0,OUTSIDE);	//O
	set_sp_pos(STR_SP+10,0,OUTSIDE);	//N

}
//---------------------------------------------------------------------------
void set_gameover_sprite(unsigned short dead_cnt)
{
	
	//Q[[o[p̃XvCgzu
	
	if(dead_cnt < DEAD_WAIT)
	{
		//vC[͍Ō̃|[Ŷ܂
		
		//Gap^[ŌŒ
		
		set_sp_pettern(ENEMY_SP  ,ENEMY_KIRU_PT  );
		set_sp_pettern(ENEMY_SP+1,ENEMY_KIRU_PT+1);
		set_sp_pettern(ENEMY_SP+2,ENEMY_KIRU_PT+2);
		set_sp_pettern(ENEMY_SP+3,ENEMY_KIRU_PT+3);
		
		set_sp_pos(ENEMY_SP  ,ENEMY_KIRU_X - 8,GROUND_Y - 8);
		set_sp_pos(ENEMY_SP+1,ENEMY_KIRU_X    ,GROUND_Y - 8);
		set_sp_pos(ENEMY_SP+2,ENEMY_KIRU_X - 8,GROUND_Y    );
		set_sp_pos(ENEMY_SP+3,ENEMY_KIRU_X    ,GROUND_Y    );

		set_sp_pos(ENEMY_BUKI_SP  ,ENEMY_KIRU_X-24,GROUND_Y);
		set_sp_pos(ENEMY_BUKI_SP+1,ENEMY_KIRU_X-16,GROUND_Y);
	}
	else
	{
		//vC[||[Y
		
		set_sp_pettern(PLAYER_SP  ,PLAYER_DEAD_PT  );
		set_sp_pettern(PLAYER_SP+1,PLAYER_DEAD_PT+1);
		
		set_sp_pos(PLAYER_SP  ,PLAYER_X-8,GROUND_Y);
		set_sp_pos(PLAYER_SP+1,PLAYER_X  ,GROUND_Y);

		set_sp_pos(PLAYER_SP+2     ,0,OUTSIDE);
		set_sp_pos(PLAYER_SP+3     ,0,OUTSIDE);
		set_sp_pos(PLAYER_BUKI_SP  ,0,OUTSIDE);
		set_sp_pos(PLAYER_BUKI_SP+1,0,OUTSIDE);
		
		//|ꉹ炷
		play_se3();
		
		//Q[I[o[Ԃɂ
		g_scene = SCENE_OVER;
	}
	
}
//---------------------------------------------------------------------------
void cloud_move(void)
{
	
	//_XvCg̈ړ
	
	if(!(g_fcnt % CLOUD_ANI_THRE))
	{
		if(g_cld_dir)
		{
			//Eֈړ
			CLOUD_X1_SPW++;
			CLOUD_X2_SPW++;
		}
		else
		{
			//ֈړ
			CLOUD_X1_SPW--;
			CLOUD_X2_SPW--;
		}
		
		//ړς
		if(++g_cld_cnt == CLOUD_MV_WIDTH)
		{
			g_cld_dir = 1 - g_cld_dir;
			g_cld_cnt = 0;
		}
	}
	
}
//---------------------------------------------------------------------------
void ground_anime(void)
{
	
	//nʂ̃pbgAj[V
	
	const unsigned char anime_palettes[] =
	{
		0x00, 0x07, 0x17, 0x07,	// wiF,ZF,F,ZF
		0x00, 0x07, 0x07, 0x17,	// wiF,ZF,ZF,F
	};
	const unsigned char* anime_pal  = g_gnd_anime ? &anime_palettes[4] : &anime_palettes[0];
	
	//nʗp̃pbgXV
	PPUADDR = 0x3F;
	PPUADDR = 0x08;
	
	PPUDATA = anime_pal[0];
	PPUDATA = anime_pal[1];
	PPUDATA = anime_pal[2];
	PPUDATA = anime_pal[3];
	
}
//---------------------------------------------------------------------------
void draw_bg_string(void)
{
	
	//BGւ̕`
	const unsigned short title_addr  = 0x2000 + (TITLE_BG_Y  << 5) + TITLE_BG_X;
	const unsigned short killed_addr = 0x2000 + (KILLED_BG_Y << 5) + KILLED_BG_X;
	
	if(g_scene == SCENE_TITLE)
	{
		//^Cg`
		PPUADDR = title_addr >> 8;
		PPUADDR = title_addr & 0xFF;
		
		PPUDATA = 'K';
		PPUDATA = 'I';
		PPUDATA = 'R';
		PPUDATA = 'U';
		PPUDATA = '!';
	}
	else if(g_scene == SCENE_OVER)
	{
		//ނ˂c`
		PPUADDR = title_addr >> 8;
		PPUADDR = title_addr & 0xFF;
		
		PPUDATA = 0xA0;	// 
		PPUDATA = 0x97;	// 
		PPUDATA = 0xAD;	// 
		PPUDATA = 0xB9;	// c
	}
	else if(g_scene == SCENE_PLAY)
	{
		//al`
		PPUADDR = killed_addr >> 8;
		PPUADDR = killed_addr & 0xFF;
		
		PPUDATA = g_k_100;
		PPUDATA = g_k_10;
		PPUDATA = g_k_1;
	}
	else if(g_scene == SCENE_ERASE)
	{
		//^Cg񕔕
		PPUADDR = title_addr >> 8;
		PPUADDR = title_addr & 0xFF;
		
		PPUDATA = ' ';
		PPUDATA = ' ';
		PPUDATA = ' ';
		PPUDATA = ' ';
		PPUDATA = ' ';
		
		//Q[ɖ߂
		g_scene = SCENE_PLAY;
	}
	
}
//---------------------------------------------------------------------------
char NesMain()
{

	//C֐
	unsigned char  button      = 0;
	unsigned char  player_x    = PLAYER_X;
	unsigned char  player_y    = GROUND_Y;
	unsigned short player_dead = 0;
	unsigned char  enemy_x     = ENEMY_X;
	unsigned char  enemy_y     = GROUND_Y;
	unsigned char  enemy_dead  = 0;
	unsigned char  level       = 1;
	
	
	//S
	init_all();
	
	//TEh̏
	setup_sound();
	
	//pbg̏
	setup_palette();
	
	//Xe[W̏
	setup_stage();
	
	//XvCg̏
	setup_sprite();
	
	//҂XvCg̕\
	set_string_sprite();
	
	//V[
	g_scene     = SCENE_TITLE;
	g_killed    = 0;
	g_push_a    = 0;
	g_pl_action = 1;
	g_fcnt      = 0;
	g_gnd_anime = 0;
	
	
	//ŏɐFXPPUɃZbgƂŗhꂽ
	//XN[ʒu邽߂ɁA
	//1XN[lZbgĂт܂
	
	//VBlank҂
	wait_vblank();
		
	//BGXN[Zbg
	set_bg_scroll(0,0);
	
	//ʕ\ON
	show_enable(1,1);
	
	
	//C[v
	while(1)
	{
		if((g_scene == SCENE_TITLE) ||
		   (g_scene == SCENE_OVER))
		{
			//^Cgʒ
			//Q[I[o[
			
			//{^҂XvCg\
			set_string_sprite();
		
			//{^Ԏ擾
			button = get_controller1();
			
			if(button & BUTTON_A)
			{
				//gKo
				if(g_push_a == 0)
				{	g_push_a = 1;	}
			}
			else if(g_push_a)
			{
				//A{^ėꂽ̂ŁAQ[ɖ߂
				//
				// A{^iKŔĂ܂ƁA
				// Q[n܂u1ANV
				// Ă܂̂ŁA{^ė
				// 悤ɂĂ܂B
				//
				
				//XvCg
				clear_string_sprite();
				
				//V[
				g_scene       = SCENE_ERASE;	//V[oR
				g_killed      = 0;
				g_push_a      = 0;
				g_pl_action   = 0;
				g_k_100       = ' ';
				g_k_10        = ' ';
				g_k_1         = '0';

				player_dead   = 0;
				enemy_x       = ENEMY_X;
				enemy_dead    = 0;
				level         = 1;
				
				g_cld_dir     = 0;
				g_cld_cnt     = 0;
				CLOUD_X1_SPW  = CLOUD_X;
				CLOUD_X2_SPW  = CLOUD_X+8;
			}
		}
		else 
		{
			//Q[
			
			if(!player_dead)
			{
				unsigned char killed = 0;
				
				//Rg[1̓͂擾
				button = get_controller1();
				
				//vC[XvCgzu
				set_player_sprite(player_x,player_y,button);
				
				//aANV̓蔻
				if((0 < g_pl_action) && (g_pl_action <= KIRU_TIME) &&
				   ((player_x + 8) <= enemy_x) && (enemy_x < player_x + 24))
				{
					if(enemy_dead == 0)
					{
						//aI
						enemy_dead = 1;
						g_killed++;
						
						if(g_killed > 100)
						{ g_killed = 0; }
						
						//xݒ
						//5l1xオāAő100lɂ̂ŁAlevel21܂
						level = 1 + (g_killed / 5);
						
						//|ꉹ炷
						play_se3();
					}
				}
				
				//G̈ʒuvZ
				enemy_x = calc_enemy_x(enemy_x,level,enemy_dead);
				if(enemy_x > STAGE_RIGHT)
				{	enemy_dead = 0;	}
				else if(!enemy_dead && (enemy_x < player_x))
				{
					//ꂽI
					player_dead = 1;
					
					//aꉹ炷
					play_se2();
				}
				
				//GXvCgzu
				set_enemy_sprite(enemy_x,enemy_y,enemy_dead);
				
				//al̕ݒ
				killed = g_killed;
				
				g_k_100 = '0' + killed / 100; killed %= 100;
				g_k_10  = '0' + killed /  10; killed %=  10;
				g_k_1   = '0' + killed;
				if(g_killed < 100){ g_k_100 = ' '; }
				if(g_killed <  10){ g_k_10  = ' '; }
				
				//t[JEgnʂ̃pbgAjJE^vZ
				g_gnd_anime = ((g_fcnt % 20) >= 10) ? 1 : 0;
			}
			else
			{
				//ANV
				
				g_pl_action = 1;	//nʂ̃pbgAj͂Ȃ悤ɂ
				
				if(player_dead < DEAD_WAIT)
				{
					player_dead++;
					
					//Q[I[opXvCg̔zu
					set_gameover_sprite(player_dead);
				}
			}
			
			//_̈ړ
			cloud_move();
		}
		
		
		//VBlank҂
		wait_vblank();
		
		//XvCg]
		start_sp_dma();

		//pbgAjBG/SP̕\OFF
		show_enable(0,0);
		
		//BGւ̕`
		draw_bg_string();
		
		//nʂ̃pbgAj
		if(!g_pl_action)
		{	ground_anime();	}
	
		//BGXN[Zbg(PPU䂳ƃXN[ʒuɕςdl炵j
		set_bg_scroll(0,0);
		
		//BG/SP̕\ĊJ
		show_enable(1,1); 

		//t[JEg4b(240)ň
		g_fcnt = (g_fcnt + 1) % 240;
	}

	return 0;
}
//---------------------------------------------------------------------------

